var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function apiMiddlewareCreator(client) {
  return ({ dispatch, getState }) => next => action => {
    if (typeof action === 'function') {
      return action(dispatch, getState, client);
    }

    const { promise, type } = action,
          rest = _objectWithoutProperties(action, ['promise', 'type']);

    if (!promise) {
      return next(action);
    }

    next(_extends({}, rest, { type: `${type}` }));
    const actionPromise = promise(client);

    actionPromise.then(result => next(_extends({}, rest, { result, type: `${type}_SUCCESS` }))).catch(error => next(_extends({}, rest, { error, type: `${type}_FAILED` })));

    return actionPromise;
  };
}

const apiMiddleware = apiMiddlewareCreator();

apiMiddleware.withExtraArgument = apiMiddlewareCreator;

export default apiMiddleware;